#line 1 "F:/MikroC/WiFi_HTTP_Demo/WiFi_HTTP_Demo.c"
#line 42 "F:/MikroC/WiFi_HTTP_Demo/WiFi_HTTP_Demo.c"
sbit Net_Wireless_MCW1001_Chip_RST at LATE2_bit;
sbit Net_Wireless_MCW1001_Chip_RST_Direction at TRISE2_bit;




sbit LCD_RS at LATB4_bit;
sbit LCD_EN at LATB5_bit;
sbit LCD_D4 at LATB0_bit;
sbit LCD_D5 at LATB1_bit;
sbit LCD_D6 at LATB2_bit;
sbit LCD_D7 at LATB3_bit;

sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;



char txt1[] = "mikroElektronika";
char txt2[] = "WiFi HTTP Demo";
char txt3[] = "example v2";
char txt4[] = "Initialize";
char txt5[] = "WiFi Module...";
char txt6[] = "Connecting to";
char txt7[] = "AccessPoint";
char txt8[] = "HTTP Server is";
char txt9[] = "running";









const unsigned int MAX_TCP_PACKET_SIZE = 489;


char channels[] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11};
char strSSID[] = "LatonaHouse";
char wpaPassword[] = "chickens";
char response, wifiStatus, connInProgressMark = 0;
char bindResponse, listenResponse, socketHandle, backLog, socketChild;

unsigned int remotePort, localPort;
char remoteIpAdd[4];

unsigned char myMacAddr[] = {0x00, 0x1e, 0xc0, 0x04, 0xa6, 0xfb};
unsigned char myIpAddr[] = {192, 168, 1, 180 };
unsigned char gwIpAddr[] = {192, 168, 1, 1 } ;
unsigned char ipMask[] = {255, 255, 255, 0 } ;

unsigned char getRequest[15];
unsigned char strTemp[9];
#line 105 "F:/MikroC/WiFi_HTTP_Demo/WiFi_HTTP_Demo.c"
unsigned char httpMethod[] = "GET /";
#line 112 "F:/MikroC/WiFi_HTTP_Demo/WiFi_HTTP_Demo.c"
const char strPageTemplate[] =
#line 157 "F:/MikroC/WiFi_HTTP_Demo/WiFi_HTTP_Demo.c"
"HTTP/1.1 200 OK\nContent-type: text/html\n\n<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"><html><head><meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\" /><meta http-equiv=\"refresh\" content=\"5;url=http://192.168.1.180\" /><title>WiFi Click HTTP Demo</title><style type=\"text/css\">body {font-family: Courier New;font-size: 10pt;}td {text-align:center;width:80px;}</style></head><body><h1>WiFi Click HTTP Demo</h1><a href=/>Reload</a><table border=\"1\"><thead><tr><th>ADC</th><th>Port A</th><th>Port B</th><th>Port C</th><th>Port D</th><th>Port E</th></tr></thead><tbody><tr><td>{$ADC}</td><td>{$PORTA}</td><td>{$PORTB}</td><td>{$PORTC}</td><td>{$PORTD}</td><td>{$PORTE}</td></tr></tbody></table></body></html>";
char strTxBuffer[896];


const char character0[] = {0,0,0,0,0,0,0,0};
const char character1[] = {0,0,0,0,0,0,16,0};
const char character2[] = {0,0,0,0,24,4,20,0};
const char character3[] = {0,0,28,2,25,5,21,0};
char rfIconMark = 1;

void DrawRfIcon() {
 char i;
 const char *ch;

 if(rfIconMark == 4) {
 ch = character0;
 rfIconMark = 0;
 } else {
 switch(rfIconMark) {
 case 1:
 ch = character1;
 break;

 case 2:
 ch = character2;
 break;

 case 3:
 ch = character3;
 break;
 }
 }
 rfIconMark++;
 Lcd_Cmd(64);
 for (i = 0; i<=7; i++) {
 Lcd_Chr_CP(ch[i]);
 }
 Lcd_Cmd(_LCD_RETURN_HOME);
 Lcd_Chr(2, 16, 0);
}



unsigned int wifiTmr = 0;
void interrupt() {
 if (TMR0IF_bit) {
 if( ++wifiTmr >= 122 ) {
 Net_Wireless_MCW1001_Time++;
 wifiTmr = 0;
 }
 TMR0IF_bit = 0;
 TMR0L = 0;
 }
}


void InitMcu() {
 ANSELA = 0x20;
 ANSELB = 0;
 ANSELC = 0;
 ANSELD = 0;
 ANSELE = 0;
 TRISA = 0b11110000;
 TRISB |= 0b11111111;
 TRISC |= 0b11111111;
 TRISD |= 0b11111111;
 TRISE |= 0b00001111;
 LATA = 0;
 LATB = 0;
 LATC = 0;
 LATD = 0;
 LATE = 0;

 SLRCON = 0;

 TMR0L = 0;
 T0CON = 0xC7;
 GIE_bit = 1;
 TMR0IE_bit = 1;

 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1,1,txt1);
 Delay_ms(2000);
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1,2,txt2);
 Lcd_Out(2,5,txt3);
 Delay_ms(2000);
 Sound_Init(&PORTE, 1);
 Net_Wireless_MCW1001_HwReset();
}


void InitWiFi() {
 char response;

 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1,1,txt4);
 Lcd_Out(2,1,txt5);
 Delay_ms(2000);

 Net_Wireless_MCW1001_TimeToWait = 1;
 response = 1;
 while(response != 0) {
 response = Net_Wireless_MCW1001_SetMode(_NET_WIRELESS_MCW1001_CP_1,
 _NET_WIRELESS_MCW1001_MODE_INFRASTRUCTURE);
 }
 Net_Wireless_MCW1001_TimeToWait = 5;
 Net_Wireless_MCW1001_SetChannelList(11, channels);
 Net_Wireless_MCW1001_SetSecurity_WPA(_NET_WIRELESS_MCW1001_CP_1, _NET_WIRELESS_MCW1001_WPA_PSK2, wpaPassword);
 Net_Wireless_MCW1001_SetSSID(_NET_WIRELESS_MCW1001_CP_1, strSSID);


 Net_Wireless_MCW1001_SetNetworkMask(ipMask);
 Net_Wireless_MCW1001_SetGatewayIP(gwIpAddr);
 Net_Wireless_MCW1001_SetMAC(myMacAddr);
 Net_Wireless_MCW1001_SetIP(myIpAddr);

 Net_Wireless_MCW1001_SetArpTime(1);
 Net_Wireless_MCW1001_SetRetryCount(5, 0);
 Net_Wireless_MCW1001_SocketAllocate(2, 0, 2048, 2048, 0, 0);
}
#line 292 "F:/MikroC/WiFi_HTTP_Demo/WiFi_HTTP_Demo.c"
int replace(char* pFind, char* pReplace) {
 unsigned int uintLength;
 int intReplacements, i;
 char* pStart;
 char* pEnd;
 intReplacements = 0;
 uintLength = strlen(pFind);
 while( (pStart = strstr(strTxBuffer, pFind)) ) {
 pEnd = pStart + uintLength;

 for( i=0; pReplace[i]!='\0'; i++ ) {
 *pStart = pReplace[i];
 pStart++;
 }
 intReplacements++;

 if ( pStart < pEnd ) {

 while( *pStart != '\0' ) {
 *pStart++ = *pEnd++;
 }
 }
 }
 return intReplacements;
}

void SendHttpResponse() {
 unsigned int numOfReceiveBytes = 0, numOfSentBytes;
 unsigned int intTotalLength, intLength;
 char* pData;

 Net_Wireless_MCW1001_TCP_ReadBytes(&socketChild, 10, getRequest,
 &numOfReceiveBytes);
 getRequest[10] = 0;

 if(memcmp(getRequest, httpMethod, 5)) {
 return;
 }



 for( intTotalLength=0;
 strPageTemplate[intTotalLength]!='\0';
 intTotalLength++ ) {
 strTxBuffer[intTotalLength] = strPageTemplate[intTotalLength];
 }
 strTxBuffer[intTotalLength] = '\0';
 WordToHex(ADC_Read(4), strTemp);
 replace("{$ADC}", strTemp);
 ShortToHex(PORTA, strTemp);
 replace("{$PORTA}", strTemp);
 ShortToHex(PORTB, strTemp);
 replace("{$PORTB}", strTemp);
 ShortToHex(PORTC, strTemp);
 replace("{$PORTC}", strTemp);
 ShortToHex(PORTD, strTemp);
 replace("{$PORTD}", strTemp);
 ShortToHex(PORTE, strTemp);
 replace("{$PORTE}", strTemp);
 pData = &strTxBuffer[0];
 intTotalLength = strlen(strTxBuffer);

 while( intTotalLength > 0 ) {
 if ( intTotalLength >= MAX_TCP_PACKET_SIZE ) {
 intLength = MAX_TCP_PACKET_SIZE;
 } else {
 intLength = intTotalLength;
 }
 Net_Wireless_MCW1001_TCP_SendBytes(socketChild, pData, intLength,
 &numOfSentBytes);
 intTotalLength -= intLength;
 pData += intLength;
 }
#line 376 "F:/MikroC/WiFi_HTTP_Demo/WiFi_HTTP_Demo.c"
}

void RunHttpServer() {
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1,1,txt8);
 Lcd_Out(2,1,txt9);
 rfIconMark = 3;
 DrawRfIcon();

 while(1) {
 socketHandle = 0;
 backLog = 1;
 localPort = 80;
 Net_Wireless_MCW1001_SocketCreate(&socketHandle, _NET_WIRELESS_MCW1001_SOCKET_TYPE_TCP);
 Net_Wireless_MCW1001_SocketBind(socketHandle, &localPort, &bindResponse);
 Net_Wireless_MCW1001_TCP_Listen(socketHandle, &backLog, &listenResponse);

 while(1) {
 socketChild = socketHandle;
 Net_Wireless_MCW1001_TCP_Accept(&socketChild, &remotePort, remoteIpAdd);

 if (socketChild != 254) {
 break;
 }
 }
 SendHttpResponse();
 Net_Wireless_MCW1001_SocketClose(socketChild);
 Net_Wireless_MCW1001_SocketClose(socketHandle);
 }
}

void SearchSSID() {
 char markFound, numOfScanRes, response, i, strTmp[33];

 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1,1,"Search SSID...");
 Delay_ms(2000);
 markFound = 0;

 while(markFound != 1) {
 while(1) {
 response = Net_Wireless_MCW1001_ScanStart(255, &numOfScanRes);

 if(response == 0) {
 break;
 }
 Delay_ms(500);
 }

 for(i = 1; i <= numOfScanRes; i++) {
 response = Net_Wireless_MCW1001_GetScanResult(i);
 strncpy(strTmp, Net_Wireless_MCW1001_ScanResult.SSID, Net_Wireless_MCW1001_ScanResult.SSIDLength);

 if(Net_Wireless_MCW1001_ScanResult.SSIDLength > 13) {
 strTmp[14] = '\0';
 strTmp[13] = '.';
 strTmp[12] = '.';
 strTmp[11] = '.';
 } else {
 strTmp[Net_Wireless_MCW1001_ScanResult.SSIDLength] = '\0';
 }
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1,1,"SSIDs Found:");
 Lcd_Out(2,1,strTmp);

 if(strncmp(Net_Wireless_MCW1001_ScanResult.SSID, strSSID, Net_Wireless_MCW1001_ScanResult.SSIDLength) == 0) {
 markFound = 1;
 Delay_ms(700);
 break;
 }
 Delay_ms(700);
 }
 }
}

void ConnectToAp() {
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1,1,txt6);
 Lcd_Out(2,1,txt7);


 Net_Wireless_MCW1001_TimeToWait = 1;
 Net_Wireless_MCW1001_Connect(_NET_WIRELESS_MCW1001_CP_1, &wifiStatus);



 Net_Wireless_MCW1001_Properties.networkStatus = _NET_WIRELESS_MCW1001_STATUS_NOTCONN_STATIC_IP;
 while(1) {
 Net_Wireless_MCW1001_GetNetworkStatus();

 if(Net_Wireless_MCW1001_Properties.networkStatus == _NET_WIRELESS_MCW1001_STATUS_CONN_STATIC_IP) {
 break;
 }
 DrawRfIcon();
 Delay_ms(1000);
 }
 Net_Wireless_MCW1001_TimeToWait = 5;
 Sound_Play(800, 40);
 Delay_ms(50);
 Sound_Play(800, 40);
}

void main() {
 InitMcu();
 UART1_Init(19200);
 Delay_ms(1000);
 InitWiFi();
 SearchSSID();
 ConnectToAp();
 RunHttpServer();
}
